#define __ECOS
#include <stdlib.h>

#include <pkgconf/net.h>
#undef _KERNEL
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/errno.h>

#include <net/if.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <net/route.h>

#include <cyg/infra/diag.h>

#include <bootp.h>
#include <network.h>
#include <arpa/inet.h>

#include <cyg/kernel/kapi.h>
#include <cyg/hal/drv_api.h>
#include <cyg/hal/hal_io.h>
#include <cyg/hal/hal_sa11x0.h>
#include <cyg/hal/hal_arch.h>
#include <cyg/io/io.h>
#include <cyg/hal/badge4.h>

#define _string(s) #s
#define string(s) _string(s)



#include <stdio.h>
#define STACK_SIZE (CYGNUM_HAL_STACK_SIZE_TYPICAL)
static char stack[STACK_SIZE];
static cyg_thread thread_data;
static cyg_handle_t thread_handle;

#define SERV_PORT 9877

static void 
simple_test(void)
{	
        int sockfd, i, tot = 0;
	struct sockaddr_in servaddr;
        ssize_t n;
        char byte[13] = "vediamosefun"; 
        char ack;
        const char *server_address;
        
	diag_printf("Start program\n");

        sockfd = socket(AF_INET, SOCK_STREAM, 0);
	
	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(SERV_PORT);
        server_address = (const char *)string(137.204.56.67);
        servaddr.sin_addr.s_addr = inet_addr(server_address); 
     
        diag_printf("go to connect\n");

	if(!connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)))
        	diag_printf("\n------CONNECTED TO THE SERVER------\n");
        else
		diag_printf("\n------CONNECTION FAILED------\n");
 
        i=0;
        while(i<1000) {
        	if((n = writen(sockfd, byte, 12)) > 0) { 
                        diag_printf("written %d bytes: %c\n", tot += n, byte[0]);
        		i++;	
                } 
        }
        
        diag_printf("End Program\n");

        close(sockfd);
}

void
net_audio_test(cyg_addrword_t param)
{
    diag_printf("Start AUDIO test\n");
    init_all_network_interfaces();
    // while(1);
    simple_test();
    cyg_thread_exit();
}



void
cyg_start(void)
{
    // Create a main thread, so we can run the scheduler and have time 'pass'
    cyg_thread_create(20,                // Priority - just a number
                      net_audio_test,    // entry
                      0,                 // entry parameter
                      "NET test",      // Name
                      &stack[0],         // Stack
                      STACK_SIZE,        // Size
                      &thread_handle,    // Handle
                      &thread_data       // Thread data structure
            );
    cyg_thread_resume(thread_handle);  // Start it
    cyg_scheduler_start();
}


